

FrameNode_Load PROC pData:DWORD, ParentFrame:LPFRAMENODE, pSkinMeshOwner:DWORD
local  pSubObj:DWORD
local  pSubData:DWORD 
local  pDataRef:DWORD 
local pType:LPGUID
local NameBuf[256]:BYTE
local ErrBuf[256]:BYTE
local pmeshnode:LPMESHNODE
local panimationset:LPANIMATIONNODE
local dwSize:DWORD
local pFrame:LPFRAMENODE
local SubFrame:LPFRAMENODE
local pmat:LPD3DXMATRIX
local dwsize:DWORD
  
xor eax,eax
mov pSubObj,eax
mov pSubData,eax
mov pDataRef,eax
mov pType,eax
mov NameBuf[0],al
mov dwSize,eax
mov pFrame,eax
mov SubFrame,eax
mov pmeshnode,eax
mov panimationset,eax
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;                                                                Get the template name (if any)
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  .if $mcall (pData,IDirectXFileData_GetName, NULL, addr dwSize)!=D3D_OK
    Errr CTXT("Failed to get Template Name Length")
  .endif
  .if dwSize!=0
        mcall [pData],IDirectXFileData_GetName, addr NameBuf, addr dwSize
  .endif
  .if NameBuf[0]== NULL                                                                     ;  // Give template a default name if none found
    invoke lstrcpy,addr NameBuf, CTXT("Template")
  .endif

;  // Set sub frame parent
  m2m SubFrame , ParentFrame

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
;GET TEMPLATE TYPE
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
.if ($mcall (pData,IDirectXFileData_GetType,addr pType))!= D3D_OK
             invoke wsprintf,addr ErrBuf, CTXT("%s nfi what it is"),addr NameBuf
             Errr ErrBuf
.endif 
; // Identify Template Type
    invoke IdentifyGUID, pType
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
  ;  .if eax==Unknown
  ;      Errr CTXT("Failed to identify xfile object !!")
  ;  .endif
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
.if eax==Mesh
    invoke MessageBox,0,CTXT("MESH !!"),CTXT("Frames Loader"),MB_OK

;** Create a meshnode, append it to this frame's list of meshes, and load a mesh into it
;** Note the usage of NULL for target object indicates it needs to be created as well as linked
                        mov esi,ParentFrame
                        assume esi:ptr FrameNode
                        mov pmeshnode,$invoke (LinkedLists_Append, [esi].pMeshes, NULL, sizeof MeshNode)
                        .if [esi].pMeshes==NULL                             ;is the list's root object NULL meaning no existing entries?
                                m2m [esi].pMeshes,pmeshnode         ;if it is, then this meshnode is the new Root (top of List)
                        .endif
                        mov esi,pmeshnode
                        assume esi:LPMESHNODE
                        mov [esi].pD3DXBlendedMesh,NULL             
                        invoke MeshNode_Create, pmeshnode, pData  ;ok now attempt to load the mesh
;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------

    .elseif eax==FrameXFormMatrix  
;       // Read the Matrix data straight into our buffer(s)    
                        mov esi,pFrame
                        assume esi:ptr FrameNode
                        lea ebx,[esi].OriginalMatrix
                        m2m pmat, ebx
		mcall [pData],IDirectXFileData_GetData, NULL, addr dwsize, addr pmat 
                        .if eax==DXFILE_OK
                              lea ebx,[esi].TransformationMatrix
                              m2m pmat, ebx
		      mcall [pData],IDirectXFileData_GetData, NULL, addr dwsize, addr pmat 
                              .if eax==DXFILE_OK
               ;                       invoke MessageBox,0,CTXT("MATRIX !!"),CTXT("Frames Loader"),MB_OK
            	     .else
  		              Errr CTXT ("Couldn't read frame transformation matrix from an x file")
                             .endif
  		.else
  		      Errr CTXT ("Couldn't read frame transformation matrix from an x file")
  		.endif


;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    .elseif eax==AnimationSet 
        ; Create the animation-node and attach it to the Parent Frame
        mov esi,pSkinMeshOwner
        assume esi:LPSKINMESH
        mov panimationset,$invoke (LinkedLists_Append, [esi].pAnimationsRoot, NULL, sizeof AnimationNode)
        .if [esi].pAnimationsRoot==NULL
            m2m  [esi].pAnimationsRoot, panimationset
        .endif
       invoke NewName,panimationset,addr NameBuf
       invoke MessageBox,0,addr NameBuf,CTXT("Frames Loader - AnimationSet"),MB_OK
       mov NameBuf[0],0

        mcall [pData],IDirectXFileData_GetNextObject, addr pSubObj
        .while eax==SUCCEEDED
	mcall [pSubObj],IDirectXFileData_GetType,addr  pType 
	.if eax==SUCCEEDED
                      .if $invoke (CmpGUID, pType , ADDR  TID_D3DRMAnimation,16) == TRUE
			;invoke SkinMesh_LoadAnimation, pSubObj, panimationset 
                                	invoke AnimationNode_Load, panimationset , pSubObj
                       .endif
            .endif
            _saferelease pSubObj
            mcall [pData],IDirectXFileData_GetNextObject,addr pSubObj
        .endw

  ;       invoke FrameNode_Load,pData, SubFrame,pSkinMeshOwner
;        invoke SkinMesh_LoadAnimationSet, pSkinMeshOwner, pData

;------------------------------------------------------------------------------------------------------------------------------------------------------------------------------
    .elseif eax==Animation
    invoke MessageBox,0,CTXT("Animation NOT part of SET !!"),CTXT("Frames Loader"),MB_OK
 ;       invoke SkinMesh_LoadAnimation,  pSkinMeshOwner, pData 





  .elseif eax==Frame                                                            ;  // Process subframe templates
;    // Create a frame
    mov pFrame ,$invoke (AppendOrInsert,NULL,sizeof FrameNode)
    mov esi,pFrame
    assume esi:ptr FrameNode
    mov [esi].LO.pName,0
    mov [esi].pMeshes,0

;    // Store the name
    invoke NewName,pFrame,addr NameBuf
    mov NameBuf[0],0

;    // Add to parent frame as sibling
;    invoke LinkedLists_AppendSibling, pFrame, eax, NULL ;    Frame->Sibling = ParentFrame->Child;
    mov eax,ParentFrame
    mov eax,[eax].LinkedObject.pChild
    mov ebx,pFrame
    mov [ebx].LinkedObject.pOlderSibling,eax

    mov eax,ParentFrame
    m2m [eax].LinkedObject.pChild, pFrame

;    // Set sub frame parent
    m2m SubFrame , pFrame

;    // Display a message describing which frame it was added to
 ;   mov ebx,pFrame
 ;   mov eax,ParentFrame
 ;   invoke wsprintf,addr NameBuf, CTXT("Child frame: %s",13,10,"Parent frame: %s"), [ebx].LinkedObject.pName, [eax].LinkedObject.pName
 ;   invoke MessageBox,NULL, addr NameBuf, CTXT("Added Frame"), MB_OK
  .endif

;  // Scan for embedded templates
 mcall [pData],IDirectXFileData_GetNextObject,addr pSubObj
  .while eax==SUCCEEDED

;    // Process embedded references
    .if ($mcall (pSubObj,IDirectXFileObject_QueryInterface,addr IID_IDirectXFileDataReference,addr pDataRef)) ==SUCCEEDED
      .if ($mcall (pDataRef,IDirectXFileDataReference_Resolve,addr pSubData))==SUCCEEDED
         invoke FrameNode_Load,pSubData, SubFrame,pSkinMeshOwner
        _saferelease pSubData
      .endif
      _saferelease pDataRef
    .endif

;    // Process non-referenced embedded templates
    .if $mcall (pSubObj,IDirectXFileObject_QueryInterface,addr IID_IDirectXFileData, addr pSubData) == SUCCEEDED
      invoke FrameNode_Load,pSubData, SubFrame,pSkinMeshOwner
      _saferelease pSubData
    .endif
    _saferelease pSubObj
    mcall [pData],IDirectXFileData_GetNextObject,addr pSubObj
  .endw

;  // Release name buffer
;  delete pName;

ret
FrameNode_Load ENDP
